/*!
 * Fuse.js v3.4.3 - Lightweight fuzzy-search (http://fusejs.io)
 * 
 * Copyright (c) 2012-2017 Kirollos Risk (http://kiro.me)
 * All Rights Reserved. Apache Software License 2.0
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 */
!function(e,t){"object"==typeof exports&&"object"==typeof module?module.exports=t():"function"==typeof define&&define.amd?define("Fuse",[],t):"object"==typeof exports?exports.Fuse=t():e.Fuse=t()}(this,function(){return function(e){var t={};function n(r){if(t[r])return t[r].exports;var o=t[r]={i:r,l:!1,exports:{}};return e[r].call(o.exports,o,o.exports,n),o.l=!0,o.exports}return n.m=e,n.c=t,n.d=function(e,t,r){n.o(e,t)||Object.defineProperty(e,t,{enumerable:!0,get:r})},n.r=function(e){"undefined"!=typeof Symbol&&Symbol.toStringTag&&Object.defineProperty(e,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(e,"__esModule",{value:!0})},n.t=function(e,t){if(1&t&&(e=n(e)),8&t)return e;if(4&t&&"object"==typeof e&&e&&e.__esModule)return e;var r=Object.create(null);if(n.r(r),Object.defineProperty(r,"default",{enumerable:!0,value:e}),2&t&&"string"!=typeof e)for(var o in e)n.d(r,o,function(t){return e[t]}.bind(null,o));return r},n.n=function(e){var t=e&&e.__esModule?function(){return e.default}:function(){return e};return n.d(t,"a",t),t},n.o=function(e,t){return Object.prototype.hasOwnProperty.call(e,t)},n.p="",n(n.s=1)}([function(e,t){e.exports=(e=>Array.isArray?Array.isArray(e):"[object Array]"===Object.prototype.toString.call(e))},function(e,t,n){const r=n(2),o=n(8),s=n(0);e.exports=class{constructor(e,{location:t=0,distance:n=100,threshold:r=.6,maxPatternLength:s=32,caseSensitive:i=!1,tokenSeparator:l=/ +/g,findAllMatches:a=!1,minMatchCharLength:c=1,id:h=null,keys:u=[],shouldSort:p=!0,getFn:f=o,sortFn:d=((e,t)=>e.score-t.score),tokenize:g=!1,matchAllTokens:m=!1,includeMatches:y=!1,includeScore:x=!1,verbose:S=!1}){this.options={location:t,distance:n,threshold:r,maxPatternLength:s,isCaseSensitive:i,tokenSeparator:l,findAllMatches:a,minMatchCharLength:c,id:h,keys:u,includeMatches:y,includeScore:x,shouldSort:p,getFn:f,sortFn:d,verbose:S,tokenize:g,matchAllTokens:m},this.setCollection(e)}setCollection(e){return this.list=e,e}search(e,t={limit:!1}){this._log(`---------\nSearch pattern: "${e}"`);const{tokenSearchers:n,fullSearcher:r}=this._prepareSearchers(e);let{weights:o,results:s}=this._search(n,r);return this._computeScore(o,s),this.options.shouldSort&&this._sort(s),t.limit&&"number"==typeof t.limit&&(s=s.slice(0,t.limit)),this._format(s)}_prepareSearchers(e=""){const t=[];if(this.options.tokenize){const n=e.split(this.options.tokenSeparator);for(let e=0,o=n.length;e<o;e+=1)t.push(new r(n[e],this.options))}return{tokenSearchers:t,fullSearcher:new r(e,this.options)}}_search(e=[],t){const n=this.list,r={},o=[];if("string"==typeof n[0]){for(let s=0,i=n.length;s<i;s+=1)this._analyze({key:"",value:n[s],record:s,index:s},{resultMap:r,results:o,tokenSearchers:e,fullSearcher:t});return{weights:null,results:o}}const s={};for(let i=0,l=n.length;i<l;i+=1){let l=n[i];for(let n=0,a=this.options.keys.length;n<a;n+=1){let a=this.options.keys[n];if("string"!=typeof a){if(s[a.name]={weight:1-a.weight||1},a.weight<=0||a.weight>1)throw new Error("Key weight has to be > 0 and <= 1");a=a.name}else s[a]={weight:1};this._analyze({key:a,value:this.options.getFn(l,a),record:l,index:i},{resultMap:r,results:o,tokenSearchers:e,fullSearcher:t})}}return{weights:s,results:o}}_analyze({key:e,arrayIndex:t=-1,value:n,record:r,index:o},{tokenSearchers:i=[],fullSearcher:l=[],resultMap:a={},results:c=[]}){if(null==n)return;let h=!1,u=-1,p=0;if("string"==typeof n){this._log(`\nKey: ${""===e?"-":e}`);let s=l.search(n);if(this._log(`Full text: "${n}", score: ${s.score}`),this.options.tokenize){let e=n.split(this.options.tokenSeparator),t=[];for(let n=0;n<i.length;n+=1){let r=i[n];this._log(`\nPattern: "${r.pattern}"`);let o=!1;for(let n=0;n<e.length;n+=1){let s=e[n],i=r.search(s),l={};i.isMatch?(l[s]=i.score,h=!0,o=!0,t.push(i.score)):(l[s]=1,this.options.matchAllTokens||t.push(1)),this._log(`Token: "${s}", score: ${l[s]}`)}o&&(p+=1)}u=t[0];let r=t.length;for(let e=1;e<r;e+=1)u+=t[e];u/=r,this._log("Token score average:",u)}let f=s.score;u>-1&&(f=(f+u)/2),this._log("Score average:",f);let d=!this.options.tokenize||!this.options.matchAllTokens||p>=i.length;if(this._log(`\nCheck Matches: ${d}`),(h||s.isMatch)&&d){let i=a[o];i?i.output.push({key:e,arrayIndex:t,value:n,score:f,matchedIndices:s.matchedIndices}):(a[o]={item:r,output:[{key:e,arrayIndex:t,value:n,score:f,matchedIndices:s.matchedIndices}]},c.push(a[o]))}}else if(s(n))for(let t=0,s=n.length;t<s;t+=1)this._analyze({key:e,arrayIndex:t,value:n[t],record:r,index:o},{resultMap:a,results:c,tokenSearchers:i,fullSearcher:l})}_computeScore(e,t){this._log("\n\nComputing score:\n");for(let n=0,r=t.length;n<r;n+=1){const r=t[n].output,o=r.length;let s=1,i=1;for(let t=0;t<o;t+=1){let n=e?e[r[t].key].weight:1,o=(1===n?r[t].score:r[t].score||.001)*n;1!==n?i=Math.min(i,o):(r[t].nScore=o,s*=o)}t[n].score=1===i?s:i,this._log(t[n])}}_sort(e){this._log("\n\nSorting...."),e.sort(this.options.sortFn)}_format(e){const t=[];if(this.options.verbose){let t=[];this._log("\n\nOutput:\n\n",JSON.stringify(e,function(e,n){if("object"==typeof n&&null!==n){if(-1!==t.indexOf(n))return;t.push(n)}return n})),t=null}let n=[];this.options.includeMatches&&n.push((e,t)=>{const n=e.output;t.matches=[];for(let e=0,r=n.length;e<r;e+=1){let r=n[e];if(0===r.matchedIndices.length)continue;let o={indices:r.matchedIndices,value:r.value};r.key&&(o.key=r.key),r.hasOwnProperty("arrayIndex")&&r.arrayIndex>-1&&(o.arrayIndex=r.arrayIndex),t.matches.push(o)}}),this.options.includeScore&&n.push((e,t)=>{t.score=e.score});for(let r=0,o=e.length;r<o;r+=1){const o=e[r];if(this.options.id&&(o.item=this.options.getFn(o.item,this.options.id)[0]),!n.length){t.push(o.item);continue}const s={item:o.item};for(let e=0,t=n.length;e<t;e+=1)n[e](o,s);t.push(s)}return t}_log(){this.options.verbose&&console.log(...arguments)}}},function(e,t,n){const r=n(3),o=n(4),s=n(7);e.exports=class{constructor(e,{location:t=0,distance:n=100,threshold:r=.6,maxPatternLength:o=32,isCaseSensitive:i=!1,tokenSeparator:l=/ +/g,findAllMatches:a=!1,minMatchCharLength:c=1}){this.options={location:t,distance:n,threshold:r,maxPatternLength:o,isCaseSensitive:i,tokenSeparator:l,findAllMatches:a,minMatchCharLength:c},this.pattern=this.options.isCaseSensitive?e:e.toLowerCase(),this.pattern.length<=o&&(this.patternAlphabet=s(this.pattern))}search(e){if(this.options.isCaseSensitive||(e=e.toLowerCase()),this.pattern===e)return{isMatch:!0,score:0,matchedIndices:[[0,e.length-1]]};const{maxPatternLength:t,tokenSeparator:n}=this.options;if(this.pattern.length>t)return r(e,this.pattern,n);const{location:s,distance:i,threshold:l,findAllMatches:a,minMatchCharLength:c}=this.options;return o(e,this.pattern,this.patternAlphabet,{location:s,distance:i,threshold:l,findAllMatches:a,minMatchCharLength:c})}}},function(e,t){const n=/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g;e.exports=((e,t,r=/ +/g)=>{let o=new RegExp(t.replace(n,"\\$&").replace(r,"|")),s=e.match(o),i=!!s,l=[];if(i)for(let t=0,n=s.length;t<n;t+=1){let n=s[t];l.push([e.indexOf(n),n.length-1])}return{score:i?.5:1,isMatch:i,matchedIndices:l}})},function(e,t,n){const r=n(5),o=n(6);e.exports=((e,t,n,{location:s=0,distance:i=100,threshold:l=.6,findAllMatches:a=!1,minMatchCharLength:c=1})=>{const h=s,u=e.length;let p=l,f=e.indexOf(t,h);const d=t.length,g=[];for(let e=0;e<u;e+=1)g[e]=0;if(-1!==f){let n=r(t,{errors:0,currentLocation:f,expectedLocation:h,distance:i});if(p=Math.min(n,p),-1!==(f=e.lastIndexOf(t,h+d))){let e=r(t,{errors:0,currentLocation:f,expectedLocation:h,distance:i});p=Math.min(e,p)}}f=-1;let m=[],y=1,x=d+u;const S=1<<d-1;for(let o=0;o<d;o+=1){let s=0,l=x;for(;s<l;){r(t,{errors:o,currentLocation:h+l,expectedLocation:h,distance:i})<=p?s=l:x=l,l=Math.floor((x-s)/2+s)}x=l;let c=Math.max(1,h-l+1),k=a?u:Math.min(h+l,u)+d,M=Array(k+2);M[k+1]=(1<<o)-1;for(let s=k;s>=c;s-=1){let l=s-1,a=n[e.charAt(l)];if(a&&(g[l]=1),M[s]=(M[s+1]<<1|1)&a,0!==o&&(M[s]|=(m[s+1]|m[s])<<1|1|m[s+1]),M[s]&S&&(y=r(t,{errors:o,currentLocation:l,expectedLocation:h,distance:i}))<=p){if(p=y,(f=l)<=h)break;c=Math.max(1,2*h-f)}}if(r(t,{errors:o+1,currentLocation:h,expectedLocation:h,distance:i})>p)break;m=M}return{isMatch:f>=0,score:0===y?.001:y,matchedIndices:o(g,c)}})},function(e,t){e.exports=((e,{errors:t=0,currentLocation:n=0,expectedLocation:r=0,distance:o=100})=>{const s=t/e.length,i=Math.abs(r-n);return o?s+i/o:i?1:s})},function(e,t){e.exports=((e=[],t=1)=>{let n=[],r=-1,o=-1,s=0;for(let i=e.length;s<i;s+=1){let i=e[s];i&&-1===r?r=s:i||-1===r||((o=s-1)-r+1>=t&&n.push([r,o]),r=-1)}return e[s-1]&&s-r>=t&&n.push([r,s-1]),n})},function(e,t){e.exports=(e=>{let t={},n=e.length;for(let r=0;r<n;r+=1)t[e.charAt(r)]=0;for(let r=0;r<n;r+=1)t[e.charAt(r)]|=1<<n-r-1;return t})},function(e,t,n){const r=n(0),o=(e,t,n)=>{if(t){const s=t.indexOf(".");let i=t,l=null;-1!==s&&(i=t.slice(0,s),l=t.slice(s+1));const a=e[i];if(null!=a)if(l||"string"!=typeof a&&"number"!=typeof a)if(r(a))for(let e=0,t=a.length;e<t;e+=1)o(a[e],l,n);else l&&o(a,l,n);else n.push(a.toString())}else n.push(e);return n};e.exports=((e,t)=>o(e,t,[]))}])});